/*

RenAttach 1.01 - Linux/UNIX email virus/trojan attachment filter
Copyright(C) 2000-2001 Jem E. Berkes

Contact author by e-mail at jberkes@pc-tools.net or berkes@pc9.org
Distribution site:
http://www.pc-tools.net/

Before compiling and executing this software you must read and agree to 
the terms in LICENSE.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program (see LICENSE); if not, write to the Free 
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  
    02111-1307  USA

*/

#define LOCAL_MAILER "/usr/bin/procmail"
#define MTA_COMMAND "/usr/sbin/sendmail"
#define MTA_TAIL "-i"
#define EXTENSIONS "COM,EXE,BAT,CMD,VBS,VBE,JS,JSE,WSF,WSH,REG,SCR,PIF"

#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>


const char VERSION[]="RenAttach 1.01 (www.pc-tools.net)";
int cursize = 128;	// sets buffer sizes; changes on the fly
FILE *mailer;
char *scratch;
bool full=false, partial=false;


int mem_error()
// Error when buffer space can not be allocated from the heap
{
fprintf(stderr, "Fatal error: unable to allocate required memory!\n");
fprintf(stderr, "This most likely indicates that the input stream (e-mail)\n");
fprintf(stderr, "has exceedingly long lines\n");
return -1;
}


char *startof_fn(char *line)
/*
Looks inside line, and returns a pointer to the start of a found
filename, or NULL if no filename is located.
*/
{
char *filename1 = new char[cursize];
char *filename2 = new char[cursize];
char *line_copy = new char[cursize];

if (filename1 == NULL)
	return NULL;
if (filename2 == NULL)
	{
	delete[] filename1;
	return NULL;
	}
if (line_copy == NULL)
	{
	delete[] filename1;
	delete[] filename2;
	return NULL;
	}

int line_length = strlen(line)+1;
for (int i=0; i<line_length; i++)
	line_copy[i] = tolower(line[i]);
char *mime_fn;
if ((mime_fn=strstr(line_copy, "name")) == NULL)
	{
	if ( (mime_fn=strstr(line_copy, "content-description:")) == NULL)
		{
		delete[] filename1;
		delete[] filename2;
		delete[] line_copy;
		return NULL;
		}
	else
		{
		mime_fn = mime_fn-line_copy+line+20;
		delete[] filename2;
		delete[] line_copy;
		if (sscanf(mime_fn, "%s", filename1) == 1)
			{
			char *loc = strstr(mime_fn, filename1);
			delete[] filename1;
			return loc;
			}
		else
			{
			delete[] filename1;
			return NULL;
			}
		}
	}
mime_fn += 4;
mime_fn = mime_fn-line_copy+line;
delete[] line_copy;
switch (sscanf(mime_fn, "%s%s", filename1, filename2))
	{
	case 1:
		{
		if (strcmp(filename1, "=") == 0)
			break;
		else if (filename1[0] == '=')
			{
			char *loc = strstr(mime_fn, filename1+1);
			delete[] filename1;
			delete[] filename2;
			return loc;
			}
		break;
		}
	case 2:
		{
		if (strcmp(filename1, "=") == 0)
			{
			char *loc = strstr(mime_fn, filename2);
			delete[] filename1;
			delete[] filename2;
			return loc;
			}
		else if (filename1[0] == '=')
			{
			char *loc = strstr(mime_fn, filename1+1);
			delete[] filename1;
			delete[] filename2;
			return loc;
			}
		break;
		}
	}
delete[] filename1;
delete[] filename2;
return NULL;
}


bool is_kosher(char *address)
// Catches bad "forward to" addresses. Tells whether address is good.
{
for (int i=0; i < (int)strlen(address); i++)
	{
	char ch = address[i];
	if (ch == '.' || ch == '_' || ch == '-' || ch == '@')
		continue;
	else if (ch >= 'a' && ch <= 'z')
		continue;
	else if (ch >= 'A' && ch <= 'Z')
		continue;
	else if (ch >= '0' && ch <= '9')
		continue;
	return false;
	}
return true;
}


int syntax(char *exec)
// Generic syntax error
{
fprintf(stderr, "\n%s\nCopyright(C) 2000-2001 Jem E. Berkes\n\n", VERSION);
fprintf(stderr, "\tRenAttach comes with ABSOLUTELY NO WARRANTY. This is\n"
		"\tfree software, and you are welcome to redistribute it\n"
		"\tunder certain conditions. See LICENSE for details.\n\n");
fprintf(stderr, "Usage: %s [-f | -p] [-t address]\n", exec);
fprintf(stderr, "-full will rename all attachments\n");
fprintf(stderr, "-partial will rename only the following extensions:\n");
fprintf(stderr, "\t%s\n", EXTENSIONS);
fprintf(stderr, "-to will forward the filtered mail to some address\n\n");
fprintf(stderr, "Examples: (insert into .forward, with quotes)\n");
fprintf(stderr, "\"|/path/renattach -f\"\n");
fprintf(stderr, "\"|/path/renattach -p -t address@domain.tld\"\n\n");
return -1;
}


bool is_match(char *filename)
/* 
In partial mode, is used to determine whether the file extension is
among the dangerous ones. Returns true if the extension is dangerous.
*/
{
char extcopy[] = EXTENSIONS;
char *ext = NULL;
int i = strlen(filename)-1;
if (i == -1)
	return true;
do	{
	if (filename[i] == '.')
		ext = filename+i+1;
	else	{
		if (i == 0)
			return false;
		else
			i--;
		}
	} while (ext == NULL);
char *token;
token = strtok(extcopy, ",");
while (token != NULL)
	{
	if (strcasecmp(token, ext) == 0)
		return true;
	token = strtok(NULL, ",");
	}
return false;
}


bool make_safe(char *orig_line, char *name)
/*
Processes lines which contain filenames. Returns true if it processes
and outputs the modified line with the filename. Note: orig_line and
name must point into the same buffer.
*/
{
if (name[0]=='\n' || name[0]==0)
	return false;
char *filename = new char[cursize];
if (filename == NULL)
	return false;
if ((sscanf(name, "%[^\"]", filename)==1) ||
	(sscanf(name, "\"%[^\"]", filename)==1) ||
	(sscanf(name, "%[^\n]", filename)==1))
	{
	if (filename[strlen(filename)-1] == '\n')
		filename[strlen(filename)-1] = 0;
	}
else
	{
	delete[] filename;
	return false;
	}
int n = (strstr(name, filename)-orig_line);
strncpy(scratch, orig_line, n);
scratch[n] = 0;
char *txtend = strstr(name, filename) + strlen(filename);
for (int i=strlen(filename)-1; (filename[i]=='.' || filename[i]==' ')
				&& i>0 ; i--)
	filename[i] = 0;
if (full)
	strcat(filename, "Rename");
else if (is_match(filename))
	strcat(filename, "Rename");
strcat(scratch, filename);
strcat(scratch, txtend);
fputs(scratch, mailer);
delete[] filename;
return true;
}


int main (int argc, char *argv[])
{
char *line, *fname;
bool inheader = true, mime_type = false;
int address = 0;

if (access(LOCAL_MAILER, X_OK) == -1)
	{
	fprintf(stderr, "Can not find/execute local mailer: %s\n", LOCAL_MAILER);
	return -1;
	}
if (access(MTA_COMMAND, X_OK) == -1)
	{
	fprintf(stderr, "Can not find/execute MTA: %s\n", MTA_COMMAND);
	return -1;
	}
if (argc == 1)
	return syntax(argv[0]);
for (int i = 1; i < argc; i++)
	{
	if (argv[i][0] != '-')
		return syntax(argv[0]);
	switch (argv[i][1])
		{
		case 'f': case 'F':
			full = true;
			break;

		case 'p': case 'P':
			partial = true;
			break;

		case 't': case 'T':
			if (argc-1 > i)
				{
				i++;
				address = i;
				}
			else
				return syntax(argv[0]);
			break;

		default:
			return syntax(argv[0]);
		}
	}
if (!full && !partial)
	{
	fprintf(stderr, "Specify either -full or -partial filtering\n");
	return -1;
	}

scratch = new char[cursize];
if (scratch == NULL)
	return mem_error();

if (address > 0)
	{
	if (!is_kosher(argv[address]))
		{
		fprintf(stderr, "\"%s\" is not a valid e-mail address\n", argv[address]);
		delete[] scratch;
		return -1;
		}
	else if (cursize < (int)(3+sizeof(MTA_COMMAND)+sizeof(MTA_TAIL)+strlen(argv[address])))
		{
		fprintf(stderr, "Address is too long\n");
		delete[] scratch;
		return -1;
		}
	else sprintf(scratch, "%s %s %s", MTA_COMMAND, MTA_TAIL, argv[address]);
	}
else
	{
	strncpy(scratch, LOCAL_MAILER, cursize);
	scratch[cursize-1] = 0;
	}

line = new char[cursize];
if (line == NULL)
	{
	delete[] scratch;
	return mem_error();
	}

mailer = popen(scratch, "w");
if (mailer == NULL)
	{
	delete[] scratch;
	delete[] line;
	return -1;
	}

while (fgets(line, cursize, stdin) != NULL)
	{
	while ( ((int)strlen(line)==cursize-1) && (line[strlen(line)-1]!='\n') )
		{
		cursize *= 2;
		char *bigger_line = new char[cursize];
		if (bigger_line == NULL)
			{
			delete[] scratch;
			delete[] line;
			return mem_error();
			}
		strcpy(bigger_line, line);
		delete[] line;
		line = bigger_line;

		delete[] scratch;
		char *bigger_scratch = new char[cursize];
		if (bigger_scratch == NULL)
			{
			delete[] line;
			return mem_error();
			}
		scratch = bigger_scratch;
		fgets(line+(cursize/2)-1, (cursize/2)+1, stdin);
		}

    if (inheader && line[0]=='\n')
            {
            inheader = false;
            fprintf(mailer, "X-Filtered-With: %s - ", VERSION);
			if (full)
				fprintf(mailer, "full filter\n\n");
			else
				fprintf(mailer, "partial filter\n\n");
			continue;
            }
    if (!mime_type && (strncasecmp(line, "Content-type:", 13)==0))
            mime_type = true;
    if (mime_type && ( (fname=startof_fn(line)) != NULL))
            {
            if (make_safe(line, fname))
                    continue;
            }
	else if (sscanf(line, "begin %*d %[^\n]", scratch)==1)
		{
		if (make_safe(line, strstr(line+5, scratch)))
			continue;
		}
	else if (mime_type && line[0]=='\n')
		mime_type = false;
	fputs(line, mailer);
	}
pclose(mailer);

delete[] scratch;
delete[] line;

return 0;	// success
}
